%%%
%%% Authors:
%%%   Nils Franzen (nils.franzen@sics.se)
%%%
%%% Copyright:
%%%   Nils Franzen, 2000
%%%
%%% Last change:
%%%   $Date: 2000/05/13 15:20:38 $ by $Author: nilsf $
%%%   $Revision: 1.3 $
%%%
%%% See the file "LICENSE" or
%%%    http://mozart.ps.uni-sb.de/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

%%% www.dynamicdrive.com provided with the basic javascript for this floating menu

/**
% Generates the basic html and javascript for a floating link menu
*/
\define STANDALONE
\ifdef STANDALONE
functor
%import Browser(browse)
export
   Style
   GenerateBody
define
   %% If these parameters are changed, don't forget to update ozdoc.css
   TABLEWIDTH=160
   MENUWIDTH=16
   LINKWIDTH=TABLEWIDTH-MENUWIDTH

   BGCOLOR="#009cff"
   
   %% Stylesheet
   Style=
   %% Background
   "BODY {\n"#
   " background: url(page.gif) repeat-y white;\n"#
   "}\n"#

   %% Slide menu
   "#slidemenubar, #slidemenubar2{\n"#
   " position:absolute;\n"#
   " left:-"#LINKWIDTH#"px;\n"#
   " width:"#TABLEWIDTH#"px;\n"#
   " top:10px;\n"#
   " border:0px solid black;\n"#
   " font:bold 12px Verdana;\n"#
   " line-height:10px;\n}\n"#
   /* 
   background-color:lightyellow;
   layer-background-color:lightyellow;
   */
   
   %% margin
   ".margin {\n"#
   " position: absolute;\n"#
   " left: 10px;\n"#
   " width: 130px;\n"#
   "}\n"#

   "BODY, P, H1, H2, H3, A {\n"#
   " font-family: sans-serif;\n"#
   "}\n"#
   
   "PRE, CODE {\n"#
   " font-family: courier, monospace;\n"#
   "}\n"#

   "P {\n"#
   " text-align: justify;\n"#
   "}\n"#

   "H1     { color: #9B0000; }\n"#
   "H2     { color: #FF9933; }\n"#
   "H3, H4 { color: #881155; }\n"#
   
   "CODE              { color: #663366; }\n"#
   ".code CODE        { color: #000000; }\n"#
   
   "SPAN.comment      { color: #B22222; }\n"#
   "SPAN.keyword      { color: #A020F0; }\n"#
   "SPAN.string       { color: #BC8F8F; }\n"#
   "SPAN.functionname { color: #0000FF; }\n"#
   "SPAN.type         { color: #228B22; }\n"#
   "SPAN.variablename { color: #B8860B; }\n"#
   "SPAN.reference    { color: #5F9EA0; }\n"#
   "SPAN.builtin      { color: #DA70D6; }\n"#

   %% Anchors
   "A:link {\n"#
   " color: #666666;\n"#
   "}\n"#

   "A:visited {\n"#
   " color: black;\n"#
   "}\n"#
   
   "A.pre { font-family: courier, monospace;\n"#
   " color: #228B22;\n"#
   "}\n"
   
   fun{MMap Ls F}
      {List.toRecord '#' {List.mapInd Ls fun{$ I X} I#{F X} end}}
   end
   
   fun{GenerateBody LinkList}
%      {Browser.browse LinkList}
      Ls={List.mapInd LinkList fun{$ I X} I-1#X end}
   in
%      "<script language=\"JavaScript1.2\">\n"#
%      "if (document.all)\n"#
%      "document.write('<ul><li>document.all<li>id=\"slidemenubar2\"<li>style=\"left:-"#LINKWIDTH#"\"<li>onMouseover=\"pull()\"<li>onMouseout=\"draw()\"</ul>')\n"#
%      "</script>\n"#

      "<script language=\"JavaScript1.2\">\n"#
      %% Use <div>...</div> in IE
      "if (document.all)\n"#
      "document.write('<div id=\"slidemenubar2\" style=\"left:-"#LINKWIDTH#"\" onMouseover=\"pull()\" onMouseout=\"draw()\">')\n"#
      "</script>\n"#
      
      
      "<layer id=\"slidemenubar\" onMouseover=\"pull()\" onMouseout=\"draw()\">\n"#
      table(width:TABLEWIDTH+1 cellspacing:0 cellpadding:0 border:0
	    {MMap Ls
	     fun{$ I#X}
		tr(if {Label X}==separator then
		      td(bgcolor:BGCOLOR width:LINKWIDTH hr(width:"80% NOSHADE"))
		   else
		      td(bgcolor:BGCOLOR width:LINKWIDTH X)
		   end
		   if I==0 then
		      td(width:MENUWIDTH valign:top rowspan:{Length Ls}
			 img(width:MENUWIDTH src:"menu.gif"))
		   else
		      nil
		   end)
	     end})#
            

      "</layer>\n"#
      
      "<script language=\"JavaScript1.2\">\n"#
      
      "function regenerate(){\n"#
      "window.location.reload()\n"#
      "}\n"#

      "function regenerate2(){\n"#
      "if (document.layers)\n"#
      "setTimeout(\"window.onresize=regenerate\",400)\n"#
      "}\n"#

      "window.onload=regenerate2\n"#

      "if (document.all){\n"#
      "document.write('</div>')\n"#

      %% IE settings
      "themenu=document.all.slidemenubar2.style\n"#
      "rightboundary="#0#"\n"#
      "leftboundary=-"#LINKWIDTH#"\n"#
      "}\n"#

      "else{\n"#

      %% Netscape settings
      "themenu=document.layers.slidemenubar\n"#
      "rightboundary="#LINKWIDTH#"\n"#
      "leftboundary="#0#"\n"#
      "}\n"#

      %%"document.write('<ul><li>document.all='+document.all+'<li>left='+leftboundary+'<li>right='+rightboundary+'<li>themenu='+themenu+'</ul>')\n"#

      "function pull(){\n"#
      "if (window.drawit)\n"#
      "clearInterval(drawit)\n"#
      "pullit=setInterval(\"pullengine()\",20)\n"#
      "}\n"#
	    
      "function draw(){\n"#
      "clearInterval(pullit)\n"#
      "drawit=setInterval(\"drawengine()\",50)\n"#
      "}\n"#
	    
      "function pullengine(){\n"#
      "if (document.all&&themenu.pixelLeft<rightboundary)\n"#
      "themenu.pixelLeft+=5\n"#
      "else if(document.layers&&themenu.left<rightboundary)\n"#
      "themenu.left+=5\n"#
      "else if (window.pullit)\n"#
      "clearInterval(pullit)\n"#
      "}\n"#
	    
      "function drawengine(){\n"#
      "if (document.all&&themenu.pixelLeft>leftboundary)\n"#
      "themenu.pixelLeft-=5\n"#
      "else if(document.layers&&themenu.left>leftboundary)\n"#
      "themenu.left-=5\n"#
      "else if (window.drawit)\n"#
      "clearInterval(drawit)\n"#
      "}\n"#
      "</script>\n"
   end
end

\endif


\ifndef STANDALONE

declare
{Show {OS.system "ozc -c LinkTable.oz --define STANDALONE"}}
{Delay 1000}
[B HTML]={Link ['LinkTable.ozf' 'HTML.ozf']}
{HTML.out "/home/nilsf/public_html/menu.html"
 html(
    head(title("Testing")
	 %link(href:Stylesheet rel:"stylesheet" type:"text/css")
	 style(B.style)
	)
    body({B.generateBody {Map [separator "Index"#"index.html" "One"#"1.html" "Two"#"2.html" separator "Source"#"src71.html"]
			  fun{$ X}
			     case X of A#B then '#'(a(href:B A) "\n") else X end
			  end}
	 }
	 "\n\n"
	 p("This works as expected") "\n"
	 'div'(style:"margin-left: 160px"
	       "\n" h1("Nisse rules, yes!")
	       "\n" p("Fooo bar " "what is this? "))
	 'div'(style:"margin-left: 200px"
	       "\n" h1("Nisse rules, yes!")
	       "\n" p('class':"margin" "Fooo bar " "what is this? ")
	       "\n" p("Fooo bar " "what is this? "))
	 "\n"
	 p("This works as expected") "\n"
	)
    )
 }
{Show 'saved ok!'}

\endif



